Subject: Re: bug#19931: 24.4; Support for OS X press and hold

From: Pankaj Jangid <[email-masked]>
Date: Sun, 13 Dec 2020 15:11:32 +0530

Juri Linkov <[email-masked]> writes:

>> And if that is patented (like the right swipe) then no other system will
>> be implementing it. Probably, we can think of something better to
>> achieve the same goal. And make it portably available to all.
>>
>> One idea:
>>
>> A new input-method: accented-cycle (C-u C-\ "accented-cycle" RET).
>>
>> Once you have this input-method selected, then repeating same key will
>> cycle through the accented options. Ofcourse sometimes it is useful to
>> cut off input method so that instead of cycling you just repeat the same
>> character in the typed text. This is already very well documented in the
>> "(emacs) 22.3 Input Method".
>>
>> Also, the newly added "transient" input method will also be added help.
>>
>> So, why "press and hold" when you can simply "glide".
>
> I don't know how "Press and hold" works on OS X, but it seems it's like
> on some smartphone screen virtual keyboards holding down a letter pops up
> a list of suggestions with accented letters.

Yes exactly similar to that.

> But any postfix input method in Emacs already works the same way, for
> example:
>
>   C-\ latin-1-postfix
>   a
>
> displays a list of possible accents to select.

Yes this almost solves the problem. Just that in case of press-and-hold,
the user doesn’t have to goto another key. The combination is the main
key and arrow-key to select the correct accent.

May be we can have a generic implementation. The next possible keys are
already displayed in the echo area. Pressing the same character key
again cycles through those options.

e e         => ë
e e e       => é
e e e e     => æ
e e e e e   => ê
e e e e e e => è

But, to be honest, I find the postfix implementation to be much faster.